-- Boss slots
freeslot("MT_BOMBCHAOS", "SPR_BMBC",
	"S_BOMBCHAOS_SPAWN", "S_BOMBCHAOS_SEE", "S_BOMBCHAOS_LOCK", "S_BOMBCHAOS_OPEN1", "S_BOMBCHAOS_WAITHIT", "S_BOMBCHAOS_ATTACK1", "S_BOMBCHAOS_DELAY", "S_BOMBCHAOS_ATTACK2")
mobjinfo[MT_BOMBCHAOS] = {
        doomednum = 952,
        spawnstate = S_BOMBCHAOS_SPAWN,
		seestate = S_BOMBCHAOS_SEE,
        spawnhealth = 8,
        reactiontime = 5,
        speed = 0,
        radius = 64*FRACUNIT,
        height = 256*FRACUNIT,
        mass = 100,
        flags = MF_BOSS|MF_SHOOTABLE|MF_SPECIAL
}

states[S_BOMBCHAOS_SPAWN] = {
        sprite = SPR_BMBC,
        frame = A,
        tics = 1,
        var1 = 1,
        var2 = 0,
		action = A_Look,
        nextstate = S_BOMBCHAOS_SPAWN
}

states[S_BOMBCHAOS_SEE] = {
        sprite = SPR_BMBC,
        frame = A,
        tics = 35,
        var1 = 7,
        var2 = 5,
        nextstate = S_BOMBCHAOS_LOCK
}

states[S_BOMBCHAOS_LOCK] = {
        sprite = SPR_BMBC,
        frame = A,
        tics = -1,
        var1 = 7,
        var2 = 5,
        nextstate = S_BOMBCHAOS_LOCK
}

states[S_BOMBCHAOS_OPEN1] = {
        sprite = SPR_BMBC,
        frame = A,
        tics = 105,
        var1 = 7,
        var2 = 5,
        nextstate = S_BOMBCHAOS_WAITHIT
}

states[S_BOMBCHAOS_WAITHIT] = {
        sprite = SPR_BMBC,
        frame = A,
        tics = 105,
        var1 = 7,
        var2 = 5,
        nextstate = S_BOMBCHAOS_WAITHIT
}

states[S_BOMBCHAOS_ATTACK1] = {
        sprite = SPR_BMBC,
        frame = A,
        tics = -1,
        var1 = 7,
        var2 = 5,
        nextstate = S_BOMBCHAOS_ATTACK1
}

states[S_BOMBCHAOS_DELAY] = {
        sprite = SPR_BCBB,
        frame = B,
        tics = 70,
        var1 = 1,
        var2 = 0,
        nextstate = S_BOMBCHAOS_ATTACK2
}

states[S_BOMBCHAOS_ATTACK2] = {
        sprite = SPR_BMBC,
        frame = A,
        tics = 175,
        var1 = 7,
        var2 = 5,
        nextstate = S_BOMBCHAOS_ATTACK2
}

-- Bombs of the boss slots
freeslot("MT_BCBOMB", "SPR_BCBB",
	"S_BC_BOMB_SPAWN", "S_BC_BOMB_DETONATED1", "S_BC_BOMB_DETONATED2", "S_BC_BOMB_BOOM")

mobjinfo[MT_BCBOMB] = {
        doomednum = 953,
        spawnstate = S_BC_BOMB_SPAWN,
		painstate = S_BC_BOMB_BOOM,
		deathstate = S_BC_BOMB_BOOM,
        spawnhealth = 2,
        reactiontime = 5,
        speed = 0,
        radius = 48*FRACUNIT,
        height = 48*FRACUNIT,
        mass = 100,
        flags = MF_SPECIAL|MF_SHOOTABLE
}

states[S_BC_BOMB_SPAWN] = {
        sprite = SPR_BCBB,
        frame = A,
        tics = 1,
        nextstate = S_BC_BOMB_SPAWN
}

states[S_BC_BOMB_DETONATED1] = {
        sprite = SPR_BCBB,
        frame = A,
        tics = -1,
        var1 = 1,
        var2 = 0,
        nextstate = S_BC_BOMB_DETONATED1
}

states[S_BC_BOMB_DETONATED2] = {
        sprite = SPR_BCBB,
        frame = B,
        tics = -1,
        var1 = 1,
        var2 = 0,
        nextstate = S_BC_BOMB_DETONATED2
}

states[S_BC_BOMB_BOOM] = {
        sprite = SPR_BCBB,
        frame = B,
        tics = -1,
        var1 = 1,
        var2 = 0,
        nextstate = S_NULL
}

-- Hook for Boss
addHook("MobjThinker", function(mo)
	if mo
	and mo.valid
		if mo.lockedboss == nil
			mo.lockedboss = false
		end
		if mo.targetsp == nil
			mo.targetsp = {}
			mo.targetsp[0] = P_SpawnMobj(0*FRACUNIT, 384*FRACUNIT, 1424*FRACUNIT, MT_LOCKONINF)
			mo.targetsp[1] = P_SpawnMobj(-384*FRACUNIT, 0*FRACUNIT, 1424*FRACUNIT, MT_LOCKONINF)
			mo.targetsp[2] = P_SpawnMobj(0*FRACUNIT, -384*FRACUNIT, 1424*FRACUNIT, MT_LOCKONINF)
			mo.targetsp[3] = P_SpawnMobj(384*FRACUNIT, 0*FRACUNIT, 1424*FRACUNIT, MT_LOCKONINF)
		end
		if mo.platforms == nil
			mo.platforms = {}
			for sector in sectors.iterate do
				if sector.tag == 11
					mo.platforms[0] = sector
				end
				if sector.tag == 12
					mo.platforms[1] = sector
				end
				if sector.tag == 13
					mo.platforms[2] = sector
				end
				if sector.tag == 14
					mo.platforms[3] = sector
				end
			end
		end
		if mo.lockedboss == true
			if not S_IdPlaying(sfx_laser) then S_StartSound(mo, sfx_laser, nil) end
		end
		if mo.state == S_BOMBCHAOS_LOCK
			if not S_IdPlaying(sfx_alarm) then S_StartSound(mo, sfx_alarm, nil) end
			if sectors[31].ceilingheight <= 1888*FRACUNIT
				sectors[31].ceilingheight = $ + 16*FRACUNIT
			else
				mo.lockedboss = true
				if not S_IdPlaying(sfx_doorc2) then S_StartSound(mo, sfx_doorc2, nil) end
				sectors[51].ceilingheight = 1904*FRACUNIT
				mo.state = S_BOMBCHAOS_ATTACK1
			end
		end
		if mo.state == S_BOMBCHAOS_ATTACK1
			if mo.firtsbombs == nil
				mo.firtsbombs = 70
			else
				mo.firtsbombs = $ - 1
			end
			if mo.firtsbombs == 70
				P_SpawnMobj(mo.x-256*FRACUNIT, mo.y-256*FRACUNIT, mo.z+768*FRACUNIT, MT_BCBOMB)
			elseif mo.firtsbombs == 60
				P_SpawnMobj(mo.x+256*FRACUNIT, mo.y-256*FRACUNIT, mo.z+768*FRACUNIT, MT_BCBOMB)
			elseif mo.firtsbombs == 50
				P_SpawnMobj(mo.x+256*FRACUNIT, mo.y+256*FRACUNIT, mo.z+768*FRACUNIT, MT_BCBOMB)
			elseif mo.firtsbombs == 40
				P_SpawnMobj(mo.x-256*FRACUNIT, mo.y+256*FRACUNIT, mo.z+768*FRACUNIT, MT_BCBOMB)
			elseif mo.firtsbombs <= 0
				mo.firtsbombs = nil
				mo.state = S_BOMBCHAOS_OPEN1
			end
		end
		if mo.state == S_BOMBCHAOS_OPEN1
			if not S_IdPlaying(sfx_alarm) then S_StartSound(mo, sfx_alarm, nil) end
			if sectors[31].ceilingheight >= 1664*FRACUNIT
				sectors[31].ceilingheight = $ - 16*FRACUNIT
			else
				mo.lockedboss = false
				if not S_IdPlaying(sfx_doorc2) then S_StartSound(mo, sfx_doorc2, nil) end
				sectors[51].ceilingheight = 1647*FRACUNIT
			end
			mo.targetsp[1].state = S_LOCKONINF3
			mo.targetsp[3].state = S_LOCKONINF3
		end
		if mo.state == S_BOMBCHAOS_WAITHIT
			mo.targetsp[1].state = S_INVISIBLE
			mo.targetsp[3].state = S_INVISIBLE
			if mo.platforms[1].ceilingheight <= 1632*FRACUNIT
				mo.platforms[1].ceilingheight = $ + 4*FRACUNIT
			end
			if mo.platforms[3].ceilingheight <= 1632*FRACUNIT
				mo.platforms[3].ceilingheight = $ + 4*FRACUNIT
			end
		end
	end
end, MT_BOMBCHAOS)

-- Hook for Bombs
addHook("MobjThinker", function(mo)
	if mo
	and mo.valid
		if mo.state == S_BC_BOMB_SPAWN
			if P_IsObjectOnGround(mo)
				S_StartSound(mo, sfx_buzz3, nil)
				mo.bombdet = 35
				mo.state = S_BC_BOMB_DETONATED1
			end
		end
		if mo.state == S_BC_BOMB_BOOM
			S_StartSound(mo, sfx_doorc2, nil)
			S_StartSound(mo, sfx_bkpoof, nil)
			local nolexplode = P_SpawnMobj(mo.x, mo.y, mo.z, MT_NIGHTSPARKLE)
			nolexplode.state = S_FBOMB_EXPL1
			for player in players.iterate do
				if player.mo
				and player.mo.valid
				and player.playerstate == PST_LIVE
					local dist = R_PointToDist2(mo.x, mo.y, player.mo.x, player.mo.y)
					local dist2 = P_AproxDistance(0, player.mo.z-mo.z)
					if (dist <192*FRACUNIT and dist2 < 192*FRACUNIT)
						P_DamageMobj(player.mo, mo, mo)
					end
					mo.state = S_NULL
				end
			end
		end
		if not mo.valid then return end
		if mo.bombdet != nil
			if mo.bombdet != 0
				mo.bombdet = $ - 1
			else
				mo.state = S_BC_BOMB_BOOM
			end
			if mo.bombdet == 1
				mo.state = S_BC_BOMB_BOOM
			elseif mo.bombdet == 2
				S_StartSound(mo, sfx_s3k5c, nil)
				mo.state = S_BC_BOMB_DETONATED1
			elseif mo.bombdet == 3
				S_StartSound(mo, sfx_s3k5c, nil)
				mo.state = S_BC_BOMB_DETONATED2
			elseif mo.bombdet == 4
				S_StartSound(mo, sfx_s3k5c, nil)
				mo.state = S_BC_BOMB_DETONATED1
			elseif mo.bombdet == 6
				S_StartSound(mo, sfx_s3k5c, nil)
				mo.state = S_BC_BOMB_DETONATED2
			elseif mo.bombdet == 8
				S_StartSound(mo, sfx_s3k5c, nil)
				mo.state = S_BC_BOMB_DETONATED1
			elseif mo.bombdet == 10
				S_StartSound(mo, sfx_s3k5c, nil)
				mo.state = S_BC_BOMB_DETONATED2
			elseif mo.bombdet == 17
				S_StartSound(mo, sfx_s3k5c, nil)
				mo.state = S_BC_BOMB_DETONATED1
			elseif mo.bombdet == 20
				S_StartSound(mo, sfx_s3k5c, nil)
				mo.state = S_BC_BOMB_DETONATED2
			elseif mo.bombdet == 27
				S_StartSound(mo, sfx_s3k5c, nil)
				mo.state = S_BC_BOMB_DETONATED1
			elseif mo.bombdet == 30
				S_StartSound(mo, sfx_s3k5c, nil)
				mo.state = S_BC_BOMB_DETONATED2
			end
		end
	end
end, MT_BCBOMB)